Dialog.create("Channel Information");
items = newArray("","1","2","3","4");
Dialog.addChoice("Fiber Shape", items,"2");
Dialog.addChoice("Bodipy", items,"1");
Dialog.show();

NbChannels=1;

NumChannel = newArray(-1,-1);
NumChannel[0]=Dialog.getChoice();
NumChannel[1]=Dialog.getChoice();

ChannelFiber = parseInt(NumChannel[0])-1;
ChannelBodipy = parseInt(NumChannel[1])-1;

///////////////////////////////////////////////////////////////

Dialog.create("Picture format");
items = newArray(".czi",".nd2",".lif",".oib");
Dialog.addRadioButtonGroup("Picture format", items, 4, 1, ".czi");
Dialog.show();
ImageFormat=Dialog.getRadioButton;
print("Image Format: "+ImageFormat);

///////////////////////////////////////////////////////////////

depart=getDirectory("Select the folder where your images are located");
list = getFileList(depart);
ExcelDir=depart+"/Excel_results/";
ROIDir=depart+"/ROI/";

File.makeDirectory(ROIDir);
File.makeDirectory(ExcelDir);

/////////////////////////////////////////////////////////////////////

Dialog.create("Reduction factor");
Dialog.addNumber("Please, introduce the denominator for MF diameter reduction for the detection of SS area:", 6);
Dialog.show();
Feret_reduction = Dialog.getNumber(); 

NameGlobalResult="RunGlobalResult";
FullName=newArray(list.length);

pict=newArray(list.length);

for (ik=0; ik<list.length; ik=ik+NbChannels) {
	if (endsWith(list[ik], ImageFormat)) {
		pict[ik]=ik+1;
	}
	else {
		pict[ik]=0;
	}
}

pict = Array.deleteValue(pict, 0);
Other_files=list.length-pict.length;
List_of_files=list.length-Other_files;

print(depart+"==> "+List_of_files+"you have images to analyse");

MinFiberFeret = newArray(10000);
FiberArea = newArray(10000);
FiberFeret = newArray(10000);
AllFibersArea = newArray(10000);
FibersName = newArray(10000);
particles=newArray(10000);
Density=newArray(10000);
nCurrentLine=0;
selec=0;

run("Colors...", "foreground=red background=black selection=pink");
run("Line Width...", "line=10");

for (ik=0; ik<list.length; ik=ik+NbChannels) {
	if (endsWith(list[ik], ImageFormat)) {
		// Generic information
		nbFibers=nFeretMean=0;
	
		GlobalName="";newGlobalName="";TempGlobalName="";
		FullName = split(list[ik],".");
		GlobalName=FullName[0];

		print("File in process: "+GlobalName);
		NameLamininResult = GlobalName+"_FiberDetails";
	
		// ROI associated to functionalities
		ROIFiberFile = ROIDir+GlobalName+"_ROI_F.zip";
		ROIIntraFiberFile = ROIDir+GlobalName+"_ROI_Intra.zip";
		ROIExtraFiberFile = ROIDir+GlobalName+"_ROI_Extra.zip";
	
		currentFile=depart+list[ik];
		newGlobalName="";
		LamininWindows=newGlobalName+ChannelFiber+"."+FullName[1];

		run("Bio-Formats Importer", "open=currentFile autoscale color_mode=Default split_channels view=Hyperstack stack_order=XYCZT series_1");
		CurrentWindows=getTitle();
		Title = split(CurrentWindows,"=");
		newGlobalName=Title[0]+"=";
		LamininWindows=newGlobalName+ChannelFiber;
		BodipyWindows=newGlobalName+ChannelBodipy;
		selectWindow(LamininWindows);

		ID = getImageID();
 		title = "WaitForUser";
  		msg = "Select the fibers to analyse pressing key T after every selection to add it to the RoiManager.\nWhen finished, click \"OK\".";
  		waitForUser(title, msg);
  		close(ID);  //make sure we still have the same image
		run("Set Measurements...", "area perimeter shape feret's area_fraction redirect=None decimal=4");
		nbFibers= roiManager("count");	
		roiManager("Save", ROIFiberFile);
		roiManager("Measure");
		selectWindow("Results");
	
		Feret_reduction=6;
		for (j=0; j<nbFibers; j++) {
			FiberArea[j]=getResult("Area", j);
			FiberFeret[j]=getResult("Feret", j);
			MinFiberFeret[j]=getResult("MinFeret", j);
		}
	
		// Save ROIs for central lipid droplet analysis
		for (j=0; j<nbFibers; j++) {
			selectWindow("ROI Manager");
			roiManager("Select", j);
			RealIntraROIwithFeret=MinFiberFeret[j]/Feret_reduction; 
			run("Enlarge...", "enlarge=-"+RealIntraROIwithFeret);
			roiManager("Add");
		}

		for (i=0 ; i<nbFibers; i++) {
			roiManager("Select", 0);
			roiManager("Delete");
		}
		
		roiManager("Set Color", "blue");
		roiManager("Set Line Width", 2);
		roiManager("Save", ROIIntraFiberFile);
		roiManager("reset");

		// Save ROIs for lipid droplet analysis in the internal periphery of the cell
		roiManager("Open", ROIFiberFile);
		nbSelectedFibers=roiManager("count");
		roiManager("Open", ROIIntraFiberFile);
		AllFibersROI=roiManager("count");
		selectWindow("ROI Manager");
		roiManager("Show All without labels");
		for (i=0 ; i<nbSelectedFibers; i++) {
			iEnlarge=i+nbSelectedFibers;
			MultiSelect= newArray(i,iEnlarge);
			roiManager("Select", MultiSelect);
			roiManager("XOR");
			roiManager("Add");

		}
	
		selectWindow("ROI Manager");
		
		for (i=0; i < AllFibersROI; i++) {
			roiManager("Select", 0);
			roiManager("Delete");
		}
		
		roiManager("Set Color", "#ffc800");
		roiManager("Set Line Width", 0);

		roiManager("Save", ROIExtraFiberFile);
		roiManager("reset");

		roiManager("Open", ROIFiberFile);
		nbSelectedFibers=roiManager("count");
		roiManager("Open", ROIIntraFiberFile);
		roiManager("Open", ROIExtraFiberFile);

		selectWindow("ROI Manager");
		close("Results");
		for (i=0 ; i<nbSelectedFibers; i++) {
			iEnlarge=i+nbSelectedFibers;
			myEnlarge=i+(2*nbSelectedFibers);
			MultiSelect= newArray(i,iEnlarge,myEnlarge);
			roiManager("Select", MultiSelect);
			roiManager("Measure");
		}

		selectWindow("Results");
		nbSelectedFibers=roiManager("count");
		for (aa=0 ; aa<nbSelectedFibers; aa++) {
			AllFibersArea[aa+selec]=getResult("Area",aa);
		}
		selec=selec+nbSelectedFibers;
		//saveAs("Results", ExcelDir+GlobalName+"_Res_AllAreas.csv");

		close(LamininWindows);
		selectWindow(BodipyWindows);

		setAutoThreshold("Default dark");
		//run("Threshold...");
		setAutoThreshold("Yen dark");
		setThreshold(70, 255);
		setOption("BlackBackground", true);
		run("Convert to Mask");
		roiManager("Show All with labels");

		TempGlobalName="";
		labels=newArray("I", "IIA", "IIX", "IIB","mixed");

		for (j=0; j<nbFibers; j++) {
			roiManager("reset");
			roiManager("Open", ROIFiberFile);
			print("File in process: "+GlobalName);
			roiManager("Select", j);
			roiManager("Set Color", "green");
			roiManager("Set Line Width", 10);
			Dialog.create("Set of fiber");
			Dialog.addChoice("Please, type the type of fiber:", labels);
			Dialog.show();
			Fiber_type = Dialog.getChoice(); 
			CurrentFibN=j;		
			TempGlobalName=GlobalName+"_"+CurrentFibN+"_"+Fiber_type;
			roiManager("Select", j);
		
			run("Analyze Particles...", "size=2-Infinity pixel display clear summarize");
			selectWindow("Results");
			saveAs("Results", ExcelDir+TempGlobalName+"_Results_ALLparticles.csv");
			close("Results");
		
			roiManager("reset");
			roiManager("Open", ROIIntraFiberFile);
			roiManager("Select", j);
			run("Analyze Particles...", "size=2-Infinity pixel display clear summarize");
			selectWindow("Results");	
			saveAs("Results", ExcelDir+TempGlobalName+"_Results_Intraparticles.csv");
			close("Results");
		
			roiManager("reset");
			roiManager("Open", ROIExtraFiberFile);
			roiManager("Select", j);
			run("Analyze Particles...", "size=2-Infinity pixel display clear summarize");
			selectWindow("Results");	
			saveAs("Results", ExcelDir+TempGlobalName+"_Results_Extraparticles.csv");
			close("Results");
		
			FibersName[nCurrentLine]=TempGlobalName+"_ALL";
			FibersName[nCurrentLine+1]=TempGlobalName+"_Int";
			FibersName[nCurrentLine+2]=TempGlobalName+"_Ext";
			nCurrentLine=nCurrentLine+3;
			roiManager("reset");
		}
	
		roiManager("reset");
		run("Close All");
	}
}

selectWindow("Summary");
Table.deleteColumn("FeretAngle");
Table.deleteColumn("FeretX");
Table.deleteColumn("FeretY");
Table.deleteColumn("Perim.");
Table.deleteColumn("Circ.");
Table.deleteColumn("Solidity");
Table.renameColumn("Feret", "Area");
Table.renameColumn("MinFeret", "Particles/um^2");
Table.renameColumn("Slice", "Fiber Analysed");

for (bb=0; bb<nCurrentLine; bb++) {
	Table.set("Fiber Analysed", bb, FibersName[bb]);
	Table.set("Area", bb, AllFibersArea[bb]);
	particles[bb]=Table.get("Count", bb); 
	Density[bb]=(particles[bb])/AllFibersArea[bb];
	Table.set("Particles/um^2", bb, Density[bb]); 
}
	
Table.update;
selectWindow("Summary");
saveAs("Text");








